(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tsparticles-engine"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.drawGrab = exports.drawGrabLine = void 0;
    const tsparticles_engine_1 = require("tsparticles-engine");
    function drawGrabLine(context, width, begin, end, colorLine, opacity) {
        (0, tsparticles_engine_1.drawLine)(context, begin, end);
        context.strokeStyle = (0, tsparticles_engine_1.getStyleFromRgb)(colorLine, opacity);
        context.lineWidth = width;
        context.stroke();
    }
    exports.drawGrabLine = drawGrabLine;
    function drawGrab(container, particle, lineColor, opacity, mousePos) {
        container.canvas.draw((ctx) => {
            const beginPos = particle.getPosition();
            drawGrabLine(ctx, particle.retina.linksWidth ?? 0, beginPos, mousePos, lineColor, opacity);
        });
    }
    exports.drawGrab = drawGrab;
});
